define([ "./deferred", "./testcontext", "./extransform", "require", "exports" ], function(e, t, n, i, o) {
    function r(e, t) {
        this._loggerStack = [], this._pendingActorsByLoggerType = {}, this._captureAllLoggersByType = {}, 
        this.envOptions = e || {}, this.caseBlackboard = {}, this.fileBlackboard = t, this.testDomainSeq = 0, 
        this._liveActors = null;
    }
    function s(e, t, n, i) {
        if (!e) throw new Error("No test definer provided!");
        this._testDefiner = e, this._exposeToTestOptions = n, this._fileBlackboard = {}, 
        this._resultsReporter = i, this._runtimeContext = null, this._superDebug = t, this._logBadThingsToLogger = null;
    }
    function a(e) {
        function t(e) {
            if (null != e && "object" == typeof e) {
                if (-1 !== n.indexOf(e)) return console.error("CYCLE with traversal", i), void 0;
                n.push(e), i.push(".");
                var o, r = i.length - 1;
                o = "toJSON" in e ? e.toJSON() : e;
                for (var s in o) if (o.hasOwnProperty(s)) {
                    var a = o[s];
                    i[r] = s, t(a);
                }
                n.pop(), i.pop();
            }
        }
        var n = [], i = [];
        t(e);
    }
    function c(e, i, o, r, s) {
        var a = {
            schema: t.LOGFAB._rawDefs,
            fileFailure: {
                fileName: e,
                moduleName: i,
                variant: o,
                exceptions: r.map(n.transformException)
            }
        };
        s(a);
    }
    function l(e) {
        return function(t) {
            e("##### LOGGEST-TEST-RUN-BEGIN #####");
            try {
                e(JSON.stringify(t));
            } catch (n) {
                console.error("JSON problem:", n.message, n.stack, n);
                try {
                    a(t.log);
                } catch (i) {
                    console.error("exx y", i);
                }
            }
            e("##### LOGGEST-TEST-RUN-END #####");
        };
    }
    var d = t.STEP_TIMEOUT_MS;
    r.prototype = {
        toString: function() {
            return "[TestRuntimeContext]";
        },
        toJSON: function() {
            return {
                type: "TestRuntimeContext"
            };
        },
        pushLogger: function(e) {
            this._loggerStack.push(e);
        },
        popLogger: function(e) {
            var t = this._loggerStack.lastIndexOf(e);
            -1 !== t && this._loggerStack.splice(t, 1);
        },
        reportPendingActor: function(e) {
            var t = e.__defName;
            this._pendingActorsByLoggerType.hasOwnProperty(t) ? this._pendingActorsByLoggerType[t].push(e) : this._pendingActorsByLoggerType[t] = [ e ];
        },
        captureAllLoggersByType: function(e, t) {
            t ? this._captureAllLoggersByType[e] = t : delete this._captureAllLoggersByType[e];
        },
        reportNewLogger: function(e, t) {
            var n = e.__defName;
            if (this._pendingActorsByLoggerType.hasOwnProperty(n) && this._pendingActorsByLoggerType[n].length) {
                var i = this._pendingActorsByLoggerType[n].shift();
                i.__attachToLogger(e);
            } else this._captureAllLoggersByType.hasOwnProperty(n) && "object" != typeof e._ident && (this._captureAllLoggersByType[n][e._ident] = e);
            return !t && this._loggerStack.length ? this._loggerStack[this._loggerStack.length - 1] : t;
        },
        reportActiveActorThisStep: function(e) {
            if (!e) throw new Error("You are passing in a null actor!");
            if (null === this._liveActors) throw new Error("We are not in a step!");
            e._activeForTestStep || (this._liveActors.push(e), e.__prepForTestStep(this));
        },
        peekLogger: function() {
            return this._loggerStack.length ? this._loggerStack[this._loggerStack.length - 1] : null;
        }
    }, o.TestDefinerRunner = s, s.prototype = {
        toString: function() {
            return "[TestDefinerRunner]";
        },
        toJSON: function() {
            return {
                type: "TestDefinerRunner"
            };
        },
        runTestStep: function(t) {
            function n() {
                for (var n = 0; n < s.length; n++) r = s[n], r._logger ? r.__failUnmetExpectations() : t.log.actorNeverGotLogger(r.__defName, r.__name), 
                r.__resetExpectations();
                f._runtimeContext._liveActors = null, e.getAllActiveDeferreds().forEach(function(e) {
                    t.log.unresolvedPromise(e);
                }), i && i(" :( timeout, fail"), t.log.timeout(), t.log.result("fail"), h.resolve(!1), 
                h = null;
            }
            const i = this._superDebug;
            i && i("====== Running Step: " + t.log._ident);
            var o, r;
            this._logBadThingsToLogger = t.log;
            var s = this._runtimeContext._liveActors = t.actors.concat();
            for (o = 0; o < t.actors.length; o++) r = t.actors[o], r.__prepForTestStep(this._runtimeContext);
            t.log.run_begin();
            var a = t.log.stepFunc(null, t.testFunc);
            if (a instanceof Error) return i && i(" :( encountered an error in the step func:", a), 
            t.log.run_end(), t.log.result("fail"), Promise.resolve(!1);
            i && i(" there are", s.length, "live actors this step", "up from", t.actors.length, "step-defined actors");
            var c = [], l = !0;
            for (o = 0; o < s.length; o++) {
                r = s[o];
                var u = r.__waitForExpectations();
                if (u.then) c.push(u), i && i(" actor", r.__defName, r.__name, "generated a promise"); else if (!u) {
                    if (i) {
                        var p;
                        p = r._expectNothing && (r._expectations.length || r._iExpectation) ? "expected nothing, got something" : r._expectationsMetSoFar ? "unsure" : "expectations not met after " + r._iExpectation, 
                        i(" :( waitVal synchronously resolved to false on " + r + " because: " + p);
                    }
                    l = !1;
                }
            }
            if (c.length) {
                var h = new e(), f = this, m = setTimeout(function() {
                    f._superDebug && f._superDebug("!! timeout fired, deferred?", null !== h), h && n();
                }, t.timeoutMS || d);
                return this._superDebug && this._superDebug("waiting on", c.length, "promises"), 
                Promise.all(c).then(function g() {
                    if (f._superDebug && f._superDebug("!! all resolved, deferred?", null !== h), h) {
                        clearTimeout(m);
                        for (var g = !0, e = 0; e < s.length; e++) r = s[e], r.__resetExpectations() || (g = !1, 
                        i && i(" :( weird actor error on: " + r));
                        f._runtimeContext._liveActors = null, t.log.run_end(), t.log.result(g ? "pass" : "fail"), 
                        h.resolve(l), h = null;
                    }
                }, function() {
                    f._superDebug && f._superDebug("!! failed, deferred?", null !== h), h && (clearTimeout(m), 
                    n());
                }), h.promise;
            }
            for (t.log.run_end(), t.log.result(l ? "pass" : "fail"), o = 0; o < s.length; o++) r = s[o], 
            r.__resetExpectations();
            return this._runtimeContext._liveActors = null, Promise.resolve(l);
        },
        skipTestStep: function(e) {
            return e.log.result("skip"), Promise.resolve(!0);
        },
        runTestCasePermutation: function(e) {
            var n = this;
            return new Promise(function(i, o) {
                function r(t) {
                    if (t || (c = !1), l >= s.__steps.length) return n._runtimeContext.popLogger(s._log), 
                    n._superDebug && n._superDebug("========= Done Case: " + e.desc + "\n"), s._log.result(c ? "pass" : "fail"), 
                    s._log.run_end(), e.log.result(c ? "pass" : "fail"), e.log.run_end(), i(c), void 0;
                    var o = s.__steps[l++], a = c || "cleanup" === o.kind;
                    a ? n.runTestStep(o).then(r) : n.skipTestStep(o).then(r);
                }
                n._superDebug && n._superDebug("========= Begin Case: " + e.desc + "\n"), e.log.run_begin();
                var s = new t.TestContext(e, 0);
                this._exposeToTestOptions && this._exposeToTestOptions.variant && (e.log.variant(this._exposeToTestOptions.variant), 
                s.setPermutationVariant(this._exposeToTestOptions.variant)), s._log.run_begin(), 
                n._runtimeContext.pushLogger(s._log);
                var a = s._log.setupFunc({}, e.setupFunc, s, n._runtimeContext);
                a instanceof Error && (n._superDebug && n._superDebug(" :( setup func error thrown!"), 
                s._log.result("fail"), e.log.result("fail"), o(!1)), s.__postSetupFunc();
                var c = !0, l = 0;
                r(!0);
            }.bind(this));
        },
        runTestCase: function(e) {
            return this._runtimeContext = new r(this._exposeToTestOptions, this._fileBlackboard), 
            this._markDefinerUnderTest(this._testDefiner), this.runTestCasePermutation(e, 0);
        },
        _markDefinerUnderTest: function(e) {
            e._runtimeContext = this._runtimeContext;
            for (var t = 0; t < e.__logfabs.length; t++) e.__logfabs[t]._underTest = this._runtimeContext;
        },
        _clearDefinerUnderTest: function(e) {
            e._runtimeContext = null;
            for (var t = 0; t < e.__logfabs.length; t++) e.__logfabs[t]._underTest = null;
        },
        runAll: function(t, n) {
            function i() {
                if (a >= c.__testCases.length) return t.removeListener("exit", o), t.removeListener("uncaughtException", r), 
                c._log.run_end(), l._clearDefinerUnderTest(c), e.clearActiveDeferreds(), s.resolve(l), 
                void 0;
                var n = c.__testCases[a++];
                l.runTestCase(n).then(i);
            }
            function o() {
                console.error("IMMINENT EVENT LOOP TERMINATION IMPLYING BAD TEST, DUMPING LOG."), 
                l.reportResults();
            }
            function r(e) {
                l._logBadThingsToLogger && l._logBadThingsToLogger.uncaughtException(e);
            }
            n && (d = n);
            var s = new e("TestDefinerRunner.runAll"), a = 0, c = this._testDefiner, l = this;
            return c._log.run_begin(), t.once("exit", o), t.on("uncaughtException", r), e.setUnhandledRejectionHandler(r), 
            i(), s.promise;
        },
        reportResults: function() {
            var e, n, i = this._testDefiner, o = {};
            n = t.LOGFAB._rawDefs;
            for (e in n) o[e] = n[e];
            n = t.__LAZYLOGFAB._rawDefs;
            for (e in n) o[e] = n[e];
            for (var r = 0; r < i.__logfabs.length; r++) {
                n = i.__logfabs[r]._rawDefs;
                for (e in n) o[e] = n[e];
            }
            var s = {
                schema: o,
                log: i._log
            };
            this._resultsReporter(s);
        }
    }, o.runTestsFromModule = function(t, n, o, r) {
        function a() {
            r && r('All tests in "' + t + '" run, ' + "generating results."), u.reportResults(), 
            p.resolve(!0);
        }
        var u, p = new e("runTestsFromModule:" + t), h = n.resultsReporter || l(o.reliableOutput), f = null;
        n && n.variant && (f = n.variant);
        var m = !1;
        return o.callbackOnError(function(e, n) {
            m || (c(t, n, f, [ e ], h), p.resolve(!0), m = !0);
        }), i([ t ], function(e) {
            var i = o.gobbleAndStopTrappingErrors();
            if (!m) {
                if (i.length) return c(t, "", f, i, h), p.resolve(!0), void 0;
                if (!e.TD) {
                    var l = new Error("Test module: '" + t + "' does not export a 'TD' symbol!");
                    return c(t, t, f, [ l ], h), p.resolve(!0), void 0;
                }
                n.hasOwnProperty("defaultStepDuration") && (d = n.defaultStepDuration), u = new s(e.TD, r, n.exposeToTest, h), 
                u.runAll(o).then(a, a);
            }
        }), p.promise;
    };
});