define(["require","exports","module","lib/create-thumbnail-image","debug","views/preview-gallery","lib/prepare-preview-blob","lib/resize-image-and-save","lib/string-utils","lib/bind-all","CustomDialog"],function(t,e,i){function n(t){c(this),this.app=t,this.settings=t.settings,this.dialog=t.dialog||u,this.resizeImageAndSave=l,this.bindEvents(),this.configure(),o("initialized")}var r=t("lib/create-thumbnail-image"),o=t("debug")("controller:preview-gallery"),a=t("views/preview-gallery"),s=t("lib/prepare-preview-blob"),l=t("lib/resize-image-and-save"),h=t("lib/string-utils"),c=t("lib/bind-all"),u=t("CustomDialog");i.exports=function(t){return new n(t)},i.exports.PreviewGalleryController=n,n.prototype.bindEvents=function(){this.app.on("storage:itemdeleted",this.onItemDeleted),this.app.on("preview",this.openPreview),this.app.on("newmedia",this.onNewMedia),this.app.on("hidden",this.onHidden),o("events bound")},n.prototype.configure=function(){this.currentItemIndex=0,this.items=[],this.thumbnailItem=null;var t=window.devicePixelRatio;this.thumbnailSize={width:this.settings.previewGallery.get("thumbnailWidth")*t,height:this.settings.previewGallery.get("thumbnailHeight")*t}},n.prototype.openPreview=function(){if(!this.app.activity.pick&&!this.view){var t=window.CONFIG_MAX_IMAGE_PIXEL_SIZE;this.view=new a,this.view.maxPreviewSize=t,this.view.render().appendTo(this.app.el),this.view.on("click:gallery",this.onGalleryButtonClick),this.view.on("click:share",this.shareCurrentItem),this.view.on("click:delete",this.deleteCurrentItem),this.view.on("click:back",this.closePreview),this.view.on("swipe",this.handleSwipe),this.view.on("click:options",this.onOptionsClick),this.view.on("loadingvideo",this.app.firer("busy")),this.view.on("playingvideo",this.app.firer("ready"));var e=this.app.inSecureMode;this.view.set("secure-mode",e),this.view.open(),this.previewItem(),this.app.emit("previewgallery:opened")}},n.prototype.closePreview=function(){this.thumbnailItem!==this.items[0]&&this.updateThumbnail(),this.view&&(this.currentItemIndex=0,this.view.close(),this.view.destroy(),this.view=null),this.app.emit("previewgallery:closed")},n.prototype.onGalleryButtonClick=function(){if(!this.app.inSecureMode){var t=window.MozActivity;this.mozActivity=new t({name:"browse",data:{type:"photos"}})}},n.prototype.onOptionsClick=function(){this.app.inSecureMode||this.view.showOptionsMenu()},n.prototype.shareCurrentItem=function(){if(!this.app.inSecureMode){var t=this.currentItemIndex,e=this.items[t],i=e.isVideo?"video/*":"image/*",n=h.lastPathComponent(e.filepath),r=function(t){var r=new window.MozActivity({name:"share",data:{type:i,number:1,blobs:[t],filenames:[n],filepaths:[e.filepath]}});r.onerror=function(){console.warn("Share activity error:",r.error.name)}};if(e.isVideo)return r(e.blob),void 0;var o=this;this.stopItemDeletedEvent=!0,this.resizeImageAndSave({blob:e.blob,size:this.settings.activity.get("maxSharePixelSize")},function(t){o.stopItemDeletedEvent=!1,r(t)})}},n.prototype.deleteCurrentItem=function(){function t(){a.hide()}function e(){a.hide(),s.updatePreviewGallery(n),r.isVideo?s.app.emit("previewgallery:deletevideo",o):s.app.emit("previewgallery:deletepicture",o)}if(!this.app.inSecureMode){var i,n=this.currentItemIndex,r=this.items[n],o=r.filepath,a=this.dialog,s=this;i=r.isVideo?navigator.mozL10n.get("delete-video?"):navigator.mozL10n.get("delete-photo?"),a.show("",i,{title:navigator.mozL10n.get("cancel"),callback:t},{title:navigator.mozL10n.get("delete"),callback:e,recommend:!1})}},n.prototype.updatePreviewGallery=function(t){if(this.items.splice(t,1),0===this.items.length)this.closePreview();else{t==this.items.length&&(this.currentItemIndex=this.items.length-1);var e=this.view?!0:!1;e&&this.previewItem()}},n.prototype.handleSwipe=function(t){"left"===t?this.next():"right"===t&&this.previous()},n.prototype.next=function(){this.currentItemIndex<this.items.length-1&&(this.currentItemIndex+=1,this.previewItem())},n.prototype.previous=function(){this.currentItemIndex>0&&(this.currentItemIndex-=1,this.previewItem())},n.prototype.onNewMedia=function(t){function e(t){i.items.unshift(t),i.updateThumbnail()}if(!this.app.activity.pick){var i=this;t.isVideo?e(t):s(t.blob,function(i){i.blob=t.blob,i.filepath=t.filepath,e(i)})}},n.prototype.previewItem=function(){var t=this.currentItemIndex,e=this.items[t];this.view.updateCountText(t+1,this.items.length),e.isVideo?this.view.showVideo(e):this.view.showImage(e)},n.prototype.onItemDeleted=function(t){if(!this.stopItemDeletedEvent){for(var e=-1,i=t.path,n=0;n<this.items.length;n++)if(this.items[n].filepath===i){e=n;break}n!==this.items.length&&this.updatePreviewGallery(e)}},n.prototype.onHidden=function(){this.app.inSecureMode&&(this.configure(),this.updateThumbnail()),this.closePreview()},n.prototype.updateThumbnail=function(){function t(t){i.app.emit("newthumbnail",t)}var e,i=this,n=this.thumbnailItem=this.items[0]||null;if(null===n)return this.app.emit("newthumbnail",null),void 0;if(n.isVideo)e=n.poster.blob;else{if(n.preview){var o=n.width/n.height,a=n.preview.width/n.preview.height;Math.abs(o-a)<.01&&(e=n.blob.slice(n.preview.start,n.preview.end,"image/jpeg"))}e||(e=n.blob)}r(e,n,this.thumbnailSize,t)}});